////////////////////////////////////////////////////////////////////////////////
// Copyright  1993 Apple Computer, Inc. All rights reserved.
////////////////////////////////////////////////////////////////////////////////
// AppleScript Registry constants
////////////////////////////////////////////////////////////////////////////////

#ifndef __ASREGISTRY__
#define __ASREGISTRY__

#ifndef __AEREGISTRY__
#include <AERegistry.h>
#endif

enum {
	kASAppleScriptSuite			= 'ascr',
	kASTypeNamesSuite			= 'tpnm',
};

// Dynamic Terminologies:
enum {
	typeAETE					= 'aete',
	typeAEUT					= 'aeut',
	kGetAETE					= 'gdte',
	kGetAEUT					= 'gdut',
	kASCommentEvent				= 'cmnt',
	kASLaunchEvent				= 'noop',
};

// User-defined record fields:
enum {
	keyASUserRecordFields		= 'usrf',
	typeUserRecordFields		= typeAEList,
};

// Operator Events:
enum {
	keyASArg					= 'arg ',
	// Binary:
	kASEqual					= kAEEquals,
	kASNotEqual					= '   ',
	kASGreaterThan				= kAEGreaterThan,
	kASGreaterThanOrEqual		= kAEGreaterThanEquals,
	kASLessThan					= kAELessThan,
	kASLessThanOrEqual			= kAELessThanEquals,
	kASStartsWith				= kAEBeginsWith,
	kASEndsWith					= kAEEndsWith,
	kASContains					= kAEContains,
	// not currently sent:
	kASConcatenate				= 'ccat',
	kASAdd						= '+   ',
	kASSubtract					= '-   ',
	kASMultiply					= '*   ',
	kASDivide					= '/   ',
	kASQuotient					= 'div ',
	kASRemainder				= 'mod ',
	kASPower					= '^   ',
	// Unary:
	kASNegate					= 'neg ',
};

// Subroutine Events:
enum {
	kASSubroutineEvent			= 'psbr',
	keyASSubroutineName			= 'snam',
};

// Subroutine event parameter prepositions:
enum {
	keyASPrepositionAt			= 'at  ',
	keyASPrepositionIn			= 'in  ',
	keyASPrepositionFrom		= 'from',
	keyASPrepositionFor			= 'for ',
	keyASPrepositionTo			= 'to  ',
	keyASPrepositionThru		= 'thru',
	keyASPrepositionThrough		= 'thgh',
	keyASPrepositionBy			= 'by  ',
	keyASPrepositionOn			= 'on  ',
	keyASPrepositionInto		= 'into',
	keyASPrepositionOnto		= 'onto',
	keyASPrepositionBetween		= 'btwn',
	keyASPrepositionAgainst		= 'agst',
	keyASPrepositionOutOf		= 'outo',
	keyASPrepositionInsteadOf	= 'isto',
	keyASPrepositionAsideFrom	= 'asdf',
	keyASPrepositionAround		= 'arnd',
	keyASPrepositionBeside		= 'bsid',
	keyASPrepositionBeneath		= 'bnth',
	keyASPrepositionUnder		= 'undr',
	keyASPrepositionOver		= 'over',
	keyASPrepositionAbove		= 'abve',
	keyASPrepositionBelow		= 'belw',
	keyASPrepositionApartFrom	= 'aprt',
	keyASPrepositionAbout		= 'abou',
	keyASPrepositionSince		= 'snce',
	keyASPrepositionUntil		= 'till',
};

// AppleScript Classes and Enums:
enum {
	cEventIdentifier			= 'evnt',
	cScript						= 'scpt',
	cSeconds					= 'scnd',
	cList						= typeAEList,
	cRecord						= typeAERecord,
};

// List properties:
enum {
	pLength						= 'leng',
	pReverse					= 'rvse',
	pRest						= 'rest',
};

// Script properties:
enum {
	pASParent					= 'pare',
};

// Properties of global environment:
enum {
	pASPrintLength				= 'prln',
	pASPrintDepth				= 'prdp',
};

// Considerations:
enum {
	enumConsiderations			= 'cons',
	kAECase						= 'case',
	kAEDiacritic				= 'diac',
	kAEWhiteSpace				= 'whit',
	kAEHyphens					= 'hyph',
	kAEExpansion				= 'expa',
	kAEPunctuation				= 'punc',
	kAEZenkakuHankaku			= 'zkhk',
	kAESmallKana				= 'skna',
	kAEKataHiragana				= 'hika',
	// AppleScript considerations:
	kASConsiderReplies			= 'rmte',
};

// System classes:
enum {
	cZone						= 'zone',
	cMachine					= 'mach',
};

////////////////////////////////////////////////////////////////////////////////
#endif
////////////////////////////////////////////////////////////////////////////////
